#ifndef __GC_H__
#define __GC_H__

#include <GC_Types.h>
#include <GC_Memory.h>
#include <GC_Context.h>
#include <GC_Exception.h>
#include <GC_Interrupt.h>
#include <GC_EXI.h>
#include <GC_BBA.h>
#include <GC_Card.h>
#include <GC_Video.h>
#include <GC_Pad.h>
#include <GC_GP.h>
#include <GC_AI.h>
#include <GC_Time.h>
#include <GC_Debug.h>

typedef void (*fp)();

extern unsigned long iCount;
extern unsigned long decCount;

unsigned long getMSR (void);

	asm (".globl getMSR");
	asm ("getMSR:");
	asm ("mfmsr r3");
	asm ("blr");

void setDecrementer (unsigned long anum);

	asm (".globl setDecrementer");
	asm ("setDecrementer:");
	asm ("mtdec r3");
	asm ("blr");

void WaitForNextFrame (void);

	asm (".globl WaitForNextFrame");
	asm ("WaitForNextFrame:");
	asm ("lis	r3, frameCount@h");
	asm ("ori	r3, r3, frameCount@l");
	asm ("lwz	r4, 0(r3)");
	asm ("FWLoop:");
	asm ("lwz	r5, 0(r3)");
	asm ("cmpw	r4, r5");
	asm ("beq FWLoop");
	asm ("blr");

void GC_System_Init (void)
{
	unsigned long interruptsEnabled;

	interruptsEnabled = GC_Interrupts_Disable ();

	resetGC = 0;
	decCount = 0;

	GC_Context_Init ();
	GC_Exception_Init ();
	GC_SystemCall_Init ();
	GC_Interrupts_Init ();

	//GC_Interrupts_Init ();
	
	//*(unsigned long*)0xCC003000 = 0;
	//*(unsigned long*)0xCC003004 = 0xFFC;

	GC_EXI_Init ();

	// SI Init
	while ((*(volatile unsigned long*)0xCC006434) & 1);
	*(unsigned long*)0xCC006434 = 0;
	*(unsigned long*)0xCC006438 = 0;

	GC_AI_Init ();

	AI_DSP_STATUS &= ~0x1F8;
	AI_DSP_STATUS |= 0x10;
	//AI_DSP_STATUS = 0;

	AI_DMA_LENGTH = 0;

	GC_Interrupts_Restore (interruptsEnabled);
}

#endif
