#ifndef __GC_MEMORY_H__
#define __GC_MEMORY_H__

#include <GC_Types.h>

void *GC_Memory_PhysicalToCached(u32 paddr);
void *GC_Memory_PhysicalToUncached(u32 paddr);
u32 GC_Memory_CachedToPhysical(void *caddr);
u32 GC_Memory_UncachedToPhysical(void *ucaddr);
void *GC_Memory_CachedToUncached(void *caddr);
void *GC_Memory_UncachedToCached(void *ucaddr);

void GC_Memory_DCInvalidateRange (void *addr, u32 n);
void GC_Memory_DCZeroRange (void* addr, u32 n);
void GC_Memory_DCFlushRange ( void* addr, u32 n);
void GC_Memory_DCFlushRangeNoSync ( void* addr, u32 n);
void GC_Memory_ICInvalidateRange ( void* addr, u32 n);
void GC_Memory_memcpy(char *dest, char *src, u32 size);
void GC_Memory_memset(char *dest, int anum, u32 size);

#endif
