#ifndef __GC_PAD_H__
#define __GC_PAD_H__

#include <GC_Types.h>

#define SI_BASE   (0xCC006400)

#define PAD_CHANNEL(chan)	(SI_BASE+(chan*12))

#define PAD_BASE_CHANNEL0     (0xCC006400)
#define PAD_BASE_CHANNEL1     (0xCC00640C)
#define PAD_BASE_CHANNEL2     (0xCC006418)
#define PAD_BASE_CHANNEL3     (0xCC006424)

#define GC_PAD1         0
#define GC_PAD2         1
#define GC_PAD3         2
#define GC_PAD4         3

/* Defines for the buttons */

#define PAD_LEFT        0x0001
#define PAD_RIGHT       0x0002
#define PAD_DOWN        0x0004
#define PAD_UP          0x0008
#define PAD_Z           0x0010
#define PAD_R           0x0020
#define PAD_L           0x0040
#define PAD_A           0x0100
#define PAD_B           0x0200
#define PAD_X           0x0400
#define PAD_Y           0x0800
#define PAD_START       0x1000

typedef struct {

  u16 button;
  s8 x;
  s8 y;
  s8 cx;
  s8 cy;
  u8 l;
  u8 r;
} GC_Pad;

void GC_PAD_Init (void);
void GC_PAD_Read(GC_Pad *pad, int chan);

#endif
