#ifndef __GC_VIDEO_H__
#define __GC_VIDEO_H__

#define VI_BASE			(unsigned long*)0xCC002000
#define VI_FBUF1		*(unsigned long*)0xCC00201C
#define VI_FBUF2		*(unsigned long*)0xCC002024
#define VI_HLINE		*(volatile signed short*)0xCC00202C


#define VI_MODE_COUNT		3

#define	VI_NTSC_640x480		0
#define	VI_PAL50_640x480	1
#define	VI_PAL60_640x480	2

#define VI_FRAMEBUFFER0		1
#define VI_FRAMEBUFFER1		2
#define VI_FRAMEBUFFER_BOTH	3

extern unsigned long frameCount;
typedef void (*vfp)(int);
extern vfp VICallback;

void GC_Video_Init (int TVmode);
unsigned long GC_Video_ClearIF (void);
vfp GC_Video_SetCallback (vfp callback);
vfp GC_Video_GetCallback (void);
void GC_Video_WaitForVBlank (void);
void GC_Video_SetBlack (unsigned char black);
void GC_Video_SetFrameBuffer (void *fbuf, int bnum);
void GC_Video_ClearFrameBuffer (void *fbuf, unsigned long color);
unsigned long GC_Video_RGBToYCbCr (unsigned char r, unsigned char g, unsigned char b);

#endif
