// GCLIB (Free GameCube SDK Libraries)
//
// GC_AI.c by Costis
//
// Version 1.0
//
// Revisions:
//
// V1.0 - Added all of the current functions, etc.
//		  Some simple Audio Interface functions,
//		  such as 16-bit stereo sample play-back
//		  have currently been implemented.

#include <GC_AI.h>

unsigned long samplePlaying;

void GC_AI_Init (void)
{
	samplePlaying = 0;
}

void GC_AI_LoadSample (void *tsample, unsigned long size)
{
	AI_DMA_STARTH = (unsigned long)tsample >> 16;
    AI_DMA_STARTL = (unsigned long)tsample & 0xFFFF;
	AI_DMA_LENGTH = (AI_DMA_LENGTH & 0x8000) | (size >> 5);
}

void GC_AI_StartSample (void)
{ 
	AI_DMA_LENGTH |= 0x8000;
	samplePlaying = 1;
}

void GC_AI_StopSample (void)
{ 
	AI_DMA_LENGTH &= 0x7FFF;
    samplePlaying = 0;
}
