// GCLIB (Free GameCube SDK Libraries)
//
// GC_Context.c by Costis
//
// Version 1.0
//
// Revisions:
//
// V1.0 - Added all of the current functions, etc.
//		  This file should be pretty much complete,
//		  other than the initialization function,
//		  which is fine for now.

#include <GC_Context.h>
#include <GC_Interrupt.h>

GC_Context *GC_DefaultContext;

// This function is incomplete.
void GC_Context_Init (void)
{
	// This should be changed to use a memory allocation function.
	GC_DefaultContext = (GC_Context*)(0x80200000);

	GC_Memory_memset ((char*)GC_DefaultContext, 0, sizeof (GC_DefaultContext));

	GC_CONTEXT_CURRENT = (unsigned long)(GC_DefaultContext);
	GC_CONTEXT_EXCEPTIONVECTOR = (unsigned long)(GC_DefaultContext) - 0x80000000;
}

	// This function must be written in PPC assembly, since
	// it must access the SPR's and the general purpose registers.
	asm(".globl GC_Context_Load");
	asm("GC_Context_Load:");
	asm("lis      r4, __GC_Context_InterruptsDisable_begin@ha");
	asm("lwz      r6,408(r3)");
	asm("addi     r5,r4, __GC_Context_InterruptsDisable_begin@l");
	asm("cmplw    r6,r5");
	asm("ble      GC_Context_Load_SkipSetSRR0");
	asm("lis      r4, __GC_Context_InterruptsDisable_end@ha");
	asm("addi     r0,r4, __GC_Context_InterruptsDisable_end@l");
	asm("cmplw    r6,r0");
	asm("bge      GC_Context_Load_SkipSetSRR0");
	asm("stw      r5,408(r3)");
	asm("GC_Context_Load_SkipSetSRR0:");
	asm("lwz      r0,0(r3)"); // Load r0 from the context struct.
	asm("lwz      r1,4(r3)"); // Load the stack pointer from the context stack.
	asm("lwz      r2,8(r3)"); // Load r2 from the context struct.
	asm("lhz      r4,418(r3)");
	asm("rlwinm.  r5,r4,0,30,30"); // Check if the context was saved by an exception.
	asm("beq      GC_Context_Load_NoException");
	asm("rlwinm   r4,r4,0,31,29"); // Clear the saved by exception status bit.
	asm("sth      r4,418(r3)");
	asm("lmw      r5,20(r3)"); // Restore registers r5 through r31
	asm("b        loc_398a");
	asm("GC_Context_Load_NoException:");
	asm("lmw      r13,52(r3)"); // Other-wise only restore registers r13 through r31
	asm("loc_398a:");
	asm("lwz      r4,424(r3)");
	asm("mtspr    913,r4"); // Restore GQR1.
	asm("lwz      r4,428(r3)");
	asm("mtspr    914,r4"); // Restore GQR2.
	asm("lwz      r4,432(r3)"); 
	asm("mtspr    915,r4"); // Restore GQR3.
	asm("lwz      r4,436(r3)");
	asm("mtspr    916,r4"); // Restore GQR4.
	asm("lwz      r4,440(r3)");
	asm("mtspr    917,r4"); // Restore GQR5.
	asm("lwz      r4,444(r3)");
	asm("mtspr    918,r4"); // Restore GQR6.
	asm("lwz      r4,448(r3)");
	asm("mtspr    919,r4"); // Restore GQR7.
	asm("lwz      r4,128(r3)");
	asm("mtcrf    0xff,r4"); // Restore CR.
	asm("lwz      r4,132(r3)");
	asm("mtlr     r4"); // Restore LR.
	asm("lwz      r4,136(r3)");
	asm("mtctr    r4"); // Restore CTR.
	asm("lwz      r4,140(r3)");
	asm("mtxer    r4"); // Restore XER.
	asm("mfmsr    r4");
	asm("rlwinm   r4,r4,0,17,15");
	asm("rlwinm   r4,r4,0,31,29");
	asm("mtmsr    r4"); 
	asm("lwz      r4,408(r3)"); 
	asm("mtsrr0   r4"); // Restore SRR0.
	asm("lwz      r4,412(r3)"); // li		  r4, -20430"); //0xB032");
	asm("mtsrr1   r4"); // Restore SRR1.
	asm("lwz      r4,16(r3)"); // Load r4 from the context struct.
	asm("lwz      r3,12(r3)"); // Load r3 from the context struct.
	asm("rfi"); // Branch to address in SRR0.

	// This function must be written in PPC assembly, since
	// it must access the SPR's and the general purpose registers.
	asm(".globl GC_Context_Save");
	asm("GC_Context_Save:");
	asm("stmw     r13,52(r3)");
	asm("mfspr    r0,913");
	asm("stw      r0,424(r3)");
	asm("mfspr    r0,914");
	asm("stw      r0,428(r3)");
	asm("mfspr    r0,915");
	asm("stw      r0,432(r3)");
	asm("mfspr    r0,916");
	asm("stw      r0,436(r3)");
	asm("mfspr    r0,917");
	asm("stw      r0,440(r3)");
	asm("mfspr    r0,918");
	asm("stw      r0,444(r3)");
	asm("mfspr    r0,919");
	asm("stw      r0,448(r3)");
	asm("mfcr     r0");
	asm("stw      r0,128(r3)");
	asm("mflr     r0");
	asm("stw      r0,132(r3)");
	asm("stw      r0,408(r3)");
	asm("mfmsr    r0");
	asm("stw      r0,412(r3)");
	asm("mfctr    r0");
	asm("stw      r0,136(r3)");
	asm("mfxer    r0");
	asm("stw      r0,140(r3)");
	asm("stw      r1,4(r3)");
	asm("stw      r2,8(r3)");
	asm("li       r0,1");
	asm("stw      r0,12(r3)");
	asm("li       r3,0");
	asm("blr");
