// GCLIB (Free GameCube SDK Libraries)
//
// GC_PAD.c by CrowTRobo and tmbinc
//
// Version 1.0
//
// Revisions:
//
// V1.0 - Simple controller initialization and
//        status reading functions for reading
//		  controller data from a specific channel.


#include <GC_PAD.h>

// Taken directly from tmbinc's IPL replacement code.
// Initializes all controllers!
void GC_PAD_Init (void)
{
	*(volatile unsigned long*)0xCC006430 = 0x00000000;
	*(volatile unsigned long*)0xCC006438 = 0x80000000;
	*(volatile unsigned long*)0xCC006430 = 0x00f70200;
	*(volatile unsigned long*)0xCC006438 = 0x80000000;
	*(volatile unsigned long*)0xCC006480 = 0x00000000;
	*(volatile unsigned long*)0xCC006434 = 0xc0010301;
	*(volatile unsigned long*)0xCC006438 = 0x00000000;
	
	(void)*(volatile unsigned long*)0xCC006434;

	*(volatile unsigned long*)0xCC006430 |= 0xF0; // enable all four controller ports

	*(volatile unsigned long*)0xCC006400  = 0x00400300;
	*(volatile unsigned long*)0xCC00640C  = 0x00400300;
	*(volatile unsigned long*)0xCC006418  = 0x00400300;
	*(volatile unsigned long*)0xCC006424  = 0x00400300;

	GC_Video_WaitForVBlank ();

	*(volatile unsigned long*)0xCC006430 = 0x00000000;
	*(volatile unsigned long*)0xCC006438 = 0x80000000;
	*(volatile unsigned long*)0xCC006430 = 0x00f70200;
	*(volatile unsigned long*)0xCC006438 = 0x80000000;
	*(volatile unsigned long*)0xCC006480 = 0x00000000;
	*(volatile unsigned long*)0xCC006434 = 0xc0010301;
	*(volatile unsigned long*)0xCC006438 = 0x00000000;
	
	(void)*(volatile unsigned long*)0xCC006434;
	
	*(volatile unsigned long*)0xCC006430 |= 0xF0; // enable all four controller ports

	*(volatile unsigned long*)0xCC006400  = 0x00400300;
	*(volatile unsigned long*)0xCC00640C  = 0x00400300;
	*(volatile unsigned long*)0xCC006418  = 0x00400300;
	*(volatile unsigned long*)0xCC006424  = 0x00400300;
}

/*
  Reads the pad info for the given controller port.
*/
// Written by CrowTRobo.
void GC_PAD_Read(GC_Pad *pad, int chan)
{

  unsigned long pdata;

  // Get the button and control stick values

  pdata = *(volatile unsigned long *)(PAD_CHANNEL(chan)+4);

  pad->button = pdata >> 16;
  pad->x = 128 + ((pdata >> 8) & 0xff);
  pad->y = 128 - (pdata & 0xff);

  // Get the c-stick and trigger values

  pdata = *(volatile unsigned long *)(PAD_CHANNEL(chan)+8);

  pad->cx = 128 + (pdata >> 24);
  pad->cy = 128 - ((pdata >> 16) & 0xff);
  pad->l = (pdata >> 8) & 0xff;
  pad->r = pdata & 0xff;
}



