// GCLIB (Free GameCube SDK Libraries)
//
// GC_Time.c by Costis
//
// Version 1.0
//
// Revisions:
//
// V1.0 - Added all of the current functions, etc.
//		  Partially incomplete time base functions.

#include "GC_Time.h"

	// Must be written in PPC assembly due
	// to the time base registers being used.
	asm(".globl GC_Time_GetTime");
	asm("GC_Time_GetTime:");
	asm("__Time_GetTime_Loop:");
	asm("mftbu 	3");
	asm("mftb 	4");
	asm("mftbu 	5");
	asm("cmpw	3,5");
	asm("bne    __Time_GetTime_Loop");
	asm("blr");

GC_Time GC_Time_GetSystemTime(void)
{
	u32 interruptsEnabled;
	GC_Time	Time;

	interruptsEnabled = GC_Interrupts_Disable();

	Time = GC_Time_GetTime() + GC_System_Time;
	
	GC_Interrupts_Restore(interruptsEnabled);

	return Time;
}

GC_Time GC_Time_ConvertToSystemTime(GC_Time Time)
{
	return Time + GC_System_Time;
}
